//+------------------------------------------------------------------+
//|                                                       WPR_T3.mq4 |
//|                                                       Dm_35 2008 |
//|                                    http://www.fxexpert.ru/forum/ |
//+------------------------------------------------------------------+
#property copyright "Dm_35"
#property link      "dm34@mail.ru"
#property indicator_separate_window
#property indicator_buffers 3
#property  indicator_color1  MidnightBlue
#property  indicator_color2  Red
#property  indicator_color3  Orange
#property  indicator_level1  -25
#property  indicator_level2  -75
#property  indicator_levelcolor SteelBlue
#property  indicator_levelstyle 2
#property  indicator_width1  1
#property  indicator_width2  1
#property  indicator_minimum -100
#property  indicator_maximum 0

extern int WPRPeriod=14;
extern int SMAPeriod=4;
//---- 
extern int  T3_Period = 10;  
extern double b = 0.7;
//---- 
//---- 
double MapBuffer[];

double     Up[];
double     Down[];
double     SignalBuffer[];
//----  
double e1, e2, e3, e4, e5, e6;
double n, c1, c2, c3, c4, w1, w2, b2, b3;
//----       e1,e2,e3,e4,e5,e6
int time2; double E1, E2, E3, E4, E5, E6;
//+------------------------------------------------------------------+ 
//|  T3 initialization function                                      |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators setting
   IndicatorBuffers(4);
   SetIndexStyle(0,DRAW_ARROW,EMPTY,1);
   SetIndexArrow(0,159);
   SetIndexBuffer(0,Up);
   SetIndexStyle(1,DRAW_ARROW,EMPTY,1);
   SetIndexArrow(1,159);
   SetIndexBuffer(1,Down);
      
   SetIndexStyle(2,DRAW_LINE,EMPTY,1);
   SetIndexDrawBegin(2,SMAPeriod);
   SetIndexBuffer(2,SignalBuffer);
   
   SetIndexBuffer(3,MapBuffer);
//---- name for DataWindow and indicator subwindow label
   IndicatorDigits(Digits+1);
   IndicatorShortName("WPR T3("+WPRPeriod+")");
   SetIndexLabel(0,"WPR");
   SetIndexLabel(1,"WPR");
   SetIndexLabel(2,"Signal");

   b2 = b*b;
   b3 = b2*b;
   c1 = -b3;
   c2 = (3*(b2 + b3));
   c3 = -3*(2*b2 + b + b3);
   c4 = (1 + 3*b + b3 + 3*b2);
   if(T3_Period < 1) 
       T3_Period = 1;
   n = 1 + 0.5*(T3_Period - 1);
   w1 = 2 / (n + 1);
   w2 = 1 - w1;
//----  
   return(0);
  }
//+------------------------------------------------------------------+
//| T3 iteration function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----+        
//       
   if(Bars-1 < T3_Period)
       return(0);
//----+        
   int MaxBar, limit, counted_bars = IndicatorCounted();
//----    
   if(counted_bars < 0)
       return(-1);
//----      
   if(counted_bars > 0) 
       counted_bars--;
//----     ,    
//         
   MaxBar = Bars - 1 - T3_Period;
//----     ,    
//          
   limit = (Bars - 1 - counted_bars);
//----  
   if(limit > MaxBar)
     {
       for(int bar = Bars - 1; bar >= MaxBar; bar--)
           MapBuffer[bar] = 0.0;
       limit = MaxBar; 
     }
//+---       
//     ,        
//+---    +=======+
   int Tnew = Time[limit+1];
   if(limit < MaxBar)
   if(Tnew == time2)
     {
       e1 = E1; 
       e2 = E2; 
       e3 = E3; 
       e4 = E4; 
       e5 = E5; 
       e6 = E6;  
     }
   else 
     {
       if(Tnew > time2)
           Print("ERROR01");
       else 
           Print("ERROR02");
       return(-1);
     }
//+--- +==========================================+
//+---    
   for(bar = limit; bar >= 0; bar--)
     {
       //+---   ,     
       //      
       //+---    +=============+ 
       if(bar == 1)
           if(((limit == 1)&&(time2 != Time[2])) || (limit > 1))
             {
               time2 = Time[2];
               E1 = e1; 
               E2 = e2; 
               E3 = e3; 
               E4 = e4; 
               E5 = e5; 
               E6 = e6;
             }
       //+---+============================================+
       e1 = w1*iWPR(NULL,0,WPRPeriod,bar) + w2*e1;
       e2 = w1*e1 + w2*e2;
       e3 = w1*e2 + w2*e3;
       e4 = w1*e3 + w2*e4;
       e5 = w1*e4 + w2*e5;
       e6 = w1*e5 + w2*e6;
       MapBuffer[bar]=c1*e6 + c2*e5 + c3*e4 + c4*e3;
     } 
   //+---   
   
   for(int i = limit; i >= 0; i-- )
   {
      SignalBuffer[i]=iMAOnArray(MapBuffer,0,SMAPeriod,0,MODE_SMA,i);
   }   
//----
   for(i = limit; i >= 0; i-- )
     {
       Up[i]=MapBuffer[i];     // Uptrend bbMacd
       Down[i]=MapBuffer[i];     // downtrend bbMacd
       if(MapBuffer[i] > MapBuffer[i+1]) Down[i] = EMPTY_VALUE;
       if(MapBuffer[i] < MapBuffer[i+1]) Up[i] = EMPTY_VALUE;
     }   
   return(0);
  }
//+-----------------------------------------------------------------+